workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == 'main'

stages:
- build
- deploy

build-oci:
  image: docker:24.0.7
  stage: build
  services:
  - docker:24.0.7-dind
  tags:
  - saas-linux-2xlarge-amd64
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    RUNNER_SCRIPT_TIMEOUT: 6h
  script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  - docker build --compress -t $IMAGE_TAG .
  - docker push $IMAGE_TAG
  retry:
    max: 2
    when:
      - always
  rules:
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == 'main'
    - if: $CI_COMMIT_BRANCH == 'unstable'

squash:
  image: registry.gitlab.com/xenia-group/foxsquish/main:latest
  stage: deploy
  services:
  - docker:24.0.7-dind
  tags:
  - saas-linux-2xlarge-amd64
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
    - eval $(ssh-agent -s)
    - echo "$REPO_SSH_KEY" | ssh-add -
  script:
    - cd /app && npm run start SOURCES=$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    - rsync -az -P -e "ssh -p 2 -o StrictHostKeyChecking=no" --include='/*' --include="$CI_COMMIT_BRANCH**" --exclude='*' /app/work/build/* xenia@sakamoto.pl:/mnt/xenia/testing
  rules:
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == 'main'
    - if: $CI_COMMIT_BRANCH == 'unstable'

